/* REXX TRY4:                                                   */
/*                                                              */
/*    Shows how to use the CONDITION function to get            */
/*    information in the trap routine.                          */

say "Type: 'exit' to end this program"

start_loop:
   signal on syntax   name who_am_i   /* establish all raised   */
   signal on error    name who_am_i   /* conditions to the      */
   signal on failure  name who_am_i   /* same trap routine      */
   signal on halt     name who_am_i
   signal on notready name who_am_i
   signal on novalue  name who_am_i
   signal on lostdigits name who_am_i
   
   do forever
      call charout ,"==> "            /* prompt for user input  */
      parse pull expression$           
      interpret expression$           /* INTERPRET user's input */
   end

end_start_loop:  exit 0

WHO_AM_I:
    say 'Name of trapped condition:' condition('C')
    say 'Description:' condition('D')
    say 'Method of invocation:' condition('I')
    say 'Current state of the trapped condition:' condition('S')
    signal start_loop
