/* REXX TRY3:                                                   */
/*                                                              */
/*    Shows how CALL traps a command ERROR.                     */
/*    Places user into interactive debugging mode.              */

say "Type: 'exit' to end this program"

start_loop:

   call on error                       /* establish error trap  */
   
   do forever
      call charout ,"Enter bad command ==> "         /* prompt  */
      parse pull expression$           
      interpret expression$           /* INTERPRET user's input */
   end

end_start_loop:  exit 0

ERROR:
    say 'ERROR:  The line entered returned an error, rc=' rc
    say 'ERROR MESSAGE:' errortext(rc)
    say 'ERROR LINE:'    sourceline(sigl)
    trace '?'             /* put user in interactive trace mode */
    say 'Interactive Trace'
    return



